/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the Subscription type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Subscription{}

// Subscription struct for Subscription
type Subscription struct {
	UserId string `json:"user_id"`
	OrganizationId string `json:"organization_id"`
	Category NotificationCategory `json:"category"`
	Channel NotificationChannel `json:"channel"`
	MinSeverity NotificationSeverity `json:"min_severity"`
	Frequency NotificationFrequency `json:"frequency"`
	Muted bool `json:"muted"`
	NotifiedAt *time.Time `json:"notified_at,omitempty"`
}

// NewSubscription instantiates a new Subscription object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSubscription(userId string, organizationId string, category NotificationCategory, channel NotificationChannel, minSeverity NotificationSeverity, frequency NotificationFrequency, muted bool) *Subscription {
	this := Subscription{}
	this.UserId = userId
	this.OrganizationId = organizationId
	this.Category = category
	this.Channel = channel
	this.MinSeverity = minSeverity
	this.Frequency = frequency
	this.Muted = muted
	return &this
}

// NewSubscriptionWithDefaults instantiates a new Subscription object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSubscriptionWithDefaults() *Subscription {
	this := Subscription{}
	return &this
}

// GetUserId returns the UserId field value
func (o *Subscription) GetUserId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.UserId
}

// GetUserIdOk returns a tuple with the UserId field value
// and a boolean to check if the value has been set.
func (o *Subscription) GetUserIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UserId, true
}

// SetUserId sets field value
func (o *Subscription) SetUserId(v string) {
	o.UserId = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *Subscription) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *Subscription) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *Subscription) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetCategory returns the Category field value
func (o *Subscription) GetCategory() NotificationCategory {
	if o == nil {
		var ret NotificationCategory
		return ret
	}

	return o.Category
}

// GetCategoryOk returns a tuple with the Category field value
// and a boolean to check if the value has been set.
func (o *Subscription) GetCategoryOk() (*NotificationCategory, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Category, true
}

// SetCategory sets field value
func (o *Subscription) SetCategory(v NotificationCategory) {
	o.Category = v
}

// GetChannel returns the Channel field value
func (o *Subscription) GetChannel() NotificationChannel {
	if o == nil {
		var ret NotificationChannel
		return ret
	}

	return o.Channel
}

// GetChannelOk returns a tuple with the Channel field value
// and a boolean to check if the value has been set.
func (o *Subscription) GetChannelOk() (*NotificationChannel, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Channel, true
}

// SetChannel sets field value
func (o *Subscription) SetChannel(v NotificationChannel) {
	o.Channel = v
}

// GetMinSeverity returns the MinSeverity field value
func (o *Subscription) GetMinSeverity() NotificationSeverity {
	if o == nil {
		var ret NotificationSeverity
		return ret
	}

	return o.MinSeverity
}

// GetMinSeverityOk returns a tuple with the MinSeverity field value
// and a boolean to check if the value has been set.
func (o *Subscription) GetMinSeverityOk() (*NotificationSeverity, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MinSeverity, true
}

// SetMinSeverity sets field value
func (o *Subscription) SetMinSeverity(v NotificationSeverity) {
	o.MinSeverity = v
}

// GetFrequency returns the Frequency field value
func (o *Subscription) GetFrequency() NotificationFrequency {
	if o == nil {
		var ret NotificationFrequency
		return ret
	}

	return o.Frequency
}

// GetFrequencyOk returns a tuple with the Frequency field value
// and a boolean to check if the value has been set.
func (o *Subscription) GetFrequencyOk() (*NotificationFrequency, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Frequency, true
}

// SetFrequency sets field value
func (o *Subscription) SetFrequency(v NotificationFrequency) {
	o.Frequency = v
}

// GetMuted returns the Muted field value
func (o *Subscription) GetMuted() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Muted
}

// GetMutedOk returns a tuple with the Muted field value
// and a boolean to check if the value has been set.
func (o *Subscription) GetMutedOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Muted, true
}

// SetMuted sets field value
func (o *Subscription) SetMuted(v bool) {
	o.Muted = v
}

// GetNotifiedAt returns the NotifiedAt field value if set, zero value otherwise.
func (o *Subscription) GetNotifiedAt() time.Time {
	if o == nil || IsNil(o.NotifiedAt) {
		var ret time.Time
		return ret
	}
	return *o.NotifiedAt
}

// GetNotifiedAtOk returns a tuple with the NotifiedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Subscription) GetNotifiedAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.NotifiedAt) {
		return nil, false
	}
	return o.NotifiedAt, true
}

// HasNotifiedAt returns a boolean if a field has been set.
func (o *Subscription) HasNotifiedAt() bool {
	if o != nil && !IsNil(o.NotifiedAt) {
		return true
	}

	return false
}

// SetNotifiedAt gets a reference to the given time.Time and assigns it to the NotifiedAt field.
func (o *Subscription) SetNotifiedAt(v time.Time) {
	o.NotifiedAt = &v
}

func (o Subscription) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Subscription) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["user_id"] = o.UserId
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["category"] = o.Category
	toSerialize["channel"] = o.Channel
	toSerialize["min_severity"] = o.MinSeverity
	toSerialize["frequency"] = o.Frequency
	toSerialize["muted"] = o.Muted
	if !IsNil(o.NotifiedAt) {
		toSerialize["notified_at"] = o.NotifiedAt
	}
	return toSerialize, nil
}

type NullableSubscription struct {
	value *Subscription
	isSet bool
}

func (v NullableSubscription) Get() *Subscription {
	return v.value
}

func (v *NullableSubscription) Set(val *Subscription) {
	v.value = val
	v.isSet = true
}

func (v NullableSubscription) IsSet() bool {
	return v.isSet
}

func (v *NullableSubscription) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSubscription(val *Subscription) *NullableSubscription {
	return &NullableSubscription{value: val, isSet: true}
}

func (v NullableSubscription) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSubscription) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


